<?php

namespace App\Controller;

use App\Repository\FilmRepository;
use App\Service\FilmManager;
use App\Service\OptionsManager;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

class VideothequePersonnelleController extends FilmAbstractController
{
	#[Route("/maliste", name:"videothequepersonnelle_maliste")]
	public function maListeAction (Request $request, OptionsManager $options, FilmRepository $filmRepository): Response
    {
        $filtersForm = $this->formPagination($request);
        $listeFilms = $filmRepository->findTousFavoritesByUser($this->getUser(), $filtersForm->getData()->toArray());
        return $this->render('videotheque/liste_'.$options->vue().'.html.twig', array(
            'listeFilms'    =>  $listeFilms,
            'titre'         =>  'Ma liste de films à voir',
            'filtersForm'   => $filtersForm->createView()
        ));
    }

    #[Route("/maliste/modifieravoir", name:"maliste_modifier_a_voir", methods: ['PATCH'])]
    public function modifierFilmDansListeAction(Request $request, EntityManagerInterface $em, FilmRepository $repo, FilmManager $filmManager): Response
    {
        $result = null;
        $film = $repo->find($request->toArray()['id_film']);
        $result = $filmManager->inverseUserWantToView($film);
        $em->flush();
        /*$resultat = $this->get('serializer')->serialize($film, 'json');*/
        return new JsonResponse((object)['newState' => $result]);
    }

    #[Route("/maliste/modifiervus", name:"maliste_modifier_vus", methods: ['PATCH'])]
    public function modifierFilmVusAction(Request $request, FilmRepository $repo, EntityManagerInterface $em, FilmManager $filmManager): Response
    {
        $result = null;

        $film = $repo->find($request->toArray()['id_film']);
        $result = $filmManager->inverseUserWhoSeen($film);
        $em->flush();
        return new JsonResponse((object)['newState' => $result]);
    }

}
